*************************************************************************
*                       M A I N   program                               *
*          for CompHEP 4.* - HERWIG 6.5  interface                      *
*************************************************************************
       PROGRAM CHERWIG
*...HERWIG common blocks
      INCLUDE 'HERWIG65.inc'        
*...Les Houches Agreement I common blocks
      INCLUDE 'LHA.inc'        
*...CompHEP-HERWIG interface common block
      INCLUDE 'COMPHEPINT.inc'
      SAVE
      EXTERNAL HWUDAT
      INTEGER NNEV,IEV

*...Switch to smear the mass of unstable particles in CompHEP out-state
      ISMEAR = 0     ! 0 - no Breit-Wigner smearing, 1- yes

*...Read CompHEP output header and input parameters
      CALL CBEGIN

********************************************************************
*...Initialise HERWIG (using CompHEP output for kin.frame)
      IPROC = -100   ! if IPROC < 0, HERWIG takes events from an external file
      CALL HWIGIN
      CALL PHYSPARS   ! set AGAIN phys.parameters according to CompHEP defaults
      
C...Compute parameter-dependent constants
       CALL HWUINC

C...Make any particle stable
      CALL HWUSTA ('PI0     ')

*********************************************************
*...Print HEPRUP common block data
c      CALL HEPRUP_PRINT

c...Initialise elementary process
      CALL HWEINI

c...Initialise user analysis
      CALL HWABEG

*...Pass CompHEP events to HERWIG
      NNEV = 0
      DO IEV = 1, NEVPY
C...Initialise event
        CALL HWUINE
C...Generate hard process
        CALL HWEPRO

*...<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
*...User code has to be set here
*... look at examples in heruser.f
*...<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        CALL HWANAL

*...Check end of file with partonic events
        IF (NUP.EQ.0) THEN
          GOTO 300
        ELSE
          NNEV = IEV
        ENDIF
      ENDDO    ! main loop
             
      CALL HWEFIN

300   CALL CEND
      WRITE(*,*) '  Processed events = ',NNEV
*...Termination of HERWIG if reaches end of event file
      CALL HWUGUP
      END
