*************************************************************************
*                          HMASSES routine                              *
*          for CompHEP 4.*  -  HERWIG 6.5 interface                     *
*************************************************************************
      SUBROUTINE SETMASS
*...HERWIG common blocks
      INCLUDE 'HERWIG65.inc'        
*...CompHEP-HERWIG interface
      INCLUDE 'COMPHEPINT.inc'
      SAVE

      INTEGER I, NPRC, IDWIG
      CHARACTER*80 NAMEWIG

*...Loop over of subprocesses
      DO NPRC = 1, NPROC

*...set out-particle masses in HERWIG according to CompHEP events
        DO I = 3, NNUP(NPRC)
          IF (XM(NPRC,I,1).gt.0.d0) THEN
             CALL HWUIDT(1,KFP(NPRC,I), IDWIG, NAMEWIG) ! HERWIG ROUTINE
             RMASS(IDWIG) = XM(NPRC, I, 1)
	  ENDIF
        ENDDO
      ENDDO
      RETURN
      END


*******************************
* evaluate momenta of beams   *
*******************************
      SUBROUTINE BEAMFRAME
*...HERWIG common blocks
      INCLUDE 'HERWIG65.inc'        
*...CompHEP-HERWIG interface
      INCLUDE 'COMPHEPINT.inc'
      SAVE

      DOUBLE PRECISION PBCMS(2,5)

*...evaluate beams momenta in CMS
      PBCMS(1,1) = 0
      PBCMS(1,2) = 0
      PBCMS(1,3) = SQRT(SQRTS**2/4 - BMASS(1)**2)
      PBCMS(1,4) = SQRTS/2
      PBCMS(1,5) = BMASS(1)
      PBCMS(2,1) = 0
      PBCMS(2,2) = 0
      PBCMS(2,3) = -SQRT(SQRTS**2/4 - BMASS(2)**2)
      PBCMS(2,4) = SQRTS/2
      PBCMS(2,5) = BMASS(2)

*...evaluate beams momenta in the collison frame using Lorentz boost
*...given from the CompHEP session
      PHEP(1,1) = PBCMS(1,1)
      PHEP(1,2) = PBCMS(1,2)
      PHEP(1,3) = SINH(RPDTY)*PBCMS(1,4) + COSH(RPDTY)*PBCMS(1,3)
      PHEP(1,4) = COSH(RPDTY)*PBCMS(1,4) + SINH(RPDTY)*PBCMS(1,3)
      PHEP(1,5) = PBCMS(1,5)
      PHEP(2,1) = PBCMS(2,1)
      PHEP(2,2) = PBCMS(2,2)
      PHEP(2,3) = SINH(RPDTY)*PBCMS(2,4) + COSH(RPDTY)*PBCMS(2,3)
      PHEP(2,4) = COSH(RPDTY)*PBCMS(2,4) + SINH(RPDTY)*PBCMS(2,3)
      PHEP(2,5) = PBCMS(2,5)
      
      RETURN
      END
