*************************************************************************
*                  CompHEP 4.*  - HERWIG 6.5  interface                 *
*************************************************************************
*... information about BNAMEs:
      INTEGER KFB             ! KF codes of the BNAME particles
      DOUBLE PRECISION SQRTS  ! sqrtS for the process
      DOUBLE PRECISION RPDTY  ! rapidity of the lab system for the process
      DOUBLE PRECISION BMASS  ! masses of the BNAME particles
      CHARACTER*80 BNAME       ! names  of the BNAME particles
      COMMON/BNAMES/
     + SQRTS,
     + RPDTY,
     + KFB(2),
     + BMASS(2),
     + BNAME(2)

*... smearing of a heavy resonase:
      INTEGER ISMEAR  ! if ISMEAR = 1, then the particle is smeared
      COMMON/ISMEAR/
     + ISMEAR

*... information about event file:
      INTEGER IS            ! FORTRAN channel number for the file
      INTEGER NEVPY         ! number of events to be processed
      INTEGER FIREVT        ! first event to be processed
      CHARACTER*500 EVFILE  ! file path+name
      CHARACTER*100 PROCESS ! process name (for comments only)
      COMMON/INPARM/
     + IS,
     + NEVPY,
     + FIREVT,
     + PROCESS,
     + EVFILE

*... information alpha_S calculation:
      INTEGER NNL             !
      DOUBLE PRECISION QCDLF !
      COMMON/QCDPAR/
     + QCDLF(6),
     + NNL

*... information about full event sample:
      INTEGER NEVTOT           ! full number of events
      DOUBLE PRECISION XSIGMAT ! total cross section
      COMMON/TOTINF/
     + XSIGMAT,
     + NEVTOT

*... information about symmetric properties of the machine:
      INTEGER IDUM   ! if IDUM = -1 the machine is symmetric
      COMMON/RANDM0/
     + IDUM

*... other information:
      INTEGER NPROC          ! number of subprocesses
      INTEGER NEV            ! number of events in each subprocess
      INTEGER NNUP           ! number of particles in each subprocess
      INTEGER KFP            ! particle KF codes in each subprocess
      DOUBLE PRECISION XM    ! particle masses in each subprocess
      DOUBLE PRECISION SIGMA ! cross section of each subprocess
      COMMON/SUBPROC/
     + NNUP(100),
     + KFP(100, 20),
     + NEV(100),
     + XM(100, 20, 3),
     + SIGMA(100),
     + NPROC
       SAVE
