*************************************************************************
*                      interface routines                               *
*          for CompHEP 4.*  -  HERWIG 6.5  interface                    *
*************************************************************************
**************************************************
*...read number of subprocesses                  *
**************************************************
      SUBROUTINE SUBNUM
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
*...CompHEP-HERWIG interface   
      INCLUDE 'COMPHEPINT.inc'

      CHARACTER*500 LINE

      OPEN (UNIT=IS, FILE=EVFILE, STATUS='OLD')
1     READ(IS,FMT='(A80)') LINE
      IF (LINE(1:26).EQ.'#Number_of_subprocesses = ') THEN
         READ(LINE,FMT='(26x,i4)') NPROC 
      ELSE
         GOTO 1
      ENDIF  
      CLOSE(IS)
      RETURN
      END           


*************************************************
*...read header of the event file               *
*************************************************
      SUBROUTINE RHEADER
      IMPLICIT NONE
*...CompHEP-HERWIG interface
      INCLUDE 'COMPHEPINT.inc'
      SAVE

      INTEGER NPRC, I
      INTEGER KFB1, KFB2
      DOUBLE PRECISION DELT
      DOUBLE PRECISION SQRTS0, RPDTY0
      CHARACTER*80 STRF1, STRF2
      CHARACTER*100 EMPTYS
      CHARACTER*100 SPROCESS
      CHARACTER*500 LINE
      CHARACTER*16 NAMEWIG
      
*...Which PevLIB version do you use?
      OPEN (UNIT=IS, FILE=EVFILE, STATUS='OLD')
      READ (IS, 1001) LINE

*...Loop over of subprocesses
      DO NPRC =1, NPROC
*...Which CompHEP version do you use?
        READ(IS,1001) LINE

*...Read particles names for the subprocess and get their KF codes 
        SPROCESS = EMPTYS(100)
        READ(IS,1009) LINE
        READ(LINE,FMT='(A100)') SPROCESS
      
        CALL R_PROC(NPRC,SPROCESS)

*...Omit string "initial state"
        READ(IS,1001) LINE

*...Read CMS energy and rapidity for Lorentz boost 
*...to transform CMS to the collision frame used in CompHEP
        SQRTS0 = SQRTS
        RPDTY0 = RPDTY
        READ(IS,1009) LINE
        READ(LINE,FMT='(G14.6)', ERR=2001) SQRTS
        READ(IS,1017) LINE
        READ(LINE,FMT='(G14.6)', ERR=2002) RPDTY
        IF (NPRC.GT.1) THEN
          DELT = ABS(SQRTS-SQRTS0)
          IF (DELT.lt.1.d-10) SQRTS = SQRTS0
          DELT = ABS(RPDTY-RPDTY0)
          IF (DELT.lt.1.d-10) RPDTY=RPDTY0
          IF ((SQRTS.NE.SQRTS0).or.(RPDTY.NE.RPDTY0)) THEN
            WRITE(*,*) 'Invalid SQRTS or RPDTY in subprocesses'
            STOP
          ENDIF
        ENDIF

*...read names of BNAMEs used in CompHEP and get their KF codes and masses
        KFB1 = KFB(1)
        KFB2 = KFB(2)
        READ(IS,1010) LINE
        READ(LINE,FMT='(A80)') STRF1
        BNAME(1) = EMPTYS(20)   
        CALL R_BEAM(STRF1, KFB(1), BNAME(1), BMASS(1), 1)
        IF(BNAME(1).EQ.'no') KFB(1) = KFP(NPRC, 1)
        IF((BNAME(1).EQ.'electron').and.(KFP(NPRC,1).lt.0)) THEN
          KFB(1) = -KFB(1)
        ENDIF

        READ(IS,1010) LINE
        READ(LINE,FMT='(A80)') STRF2
        BNAME(2) = EMPTYS(20)
        CALL R_BEAM(STRF2, KFB(2), BNAME(2), BMASS(2), 2)
        IF(BNAME(2).EQ.'no') KFB(2)=KFP(NPRC,2)
        IF((BNAME(2).EQ.'electron').and.(KFP(NPRC,2).lt.0)) THEN
          KFB(2) = -KFB(2)
        ENDIF

        IF ((NPRC.GT.1).and.((KFB1.NE.KFB(1)).or.(KFB2.NE.KFB(2)))) THEN
          WRITE(*,*) 'Invalid BNAMEs in subprocesses'
          STOP
        ENDIF

*...read particles masses in the subprocess
        READ(IS,1008) LINE
        READ(LINE,FMT='(20(G17.10))',ERR=2003) (XM(NPRC,I,1),
     +  I = 1, NNUP(NPRC))
30      CONTINUE

*...read cross section of the subprocess (pb)
        READ(IS,1021) LINE
        READ(LINE,FMT='(G13.6)', ERR=2004) SIGMA(NPRC)

*...read number of (unweighted) events in the input
        READ(IS,1023) LINE
        READ(LINE,FMT='(i10)', ERR=2005)  NEV(NPRC)

*...omit string: #----------------------------------------------------------
        READ(IS,1001) LINE

*...end of loop over subprocess headers
      ENDDO

*...Avoid conflict with "remnant" approach to ISR for electron BNAME:
        SQRTS = SQRTS * 1.0000001

*...omit string: #Number_of_subprocesses = xxx
      READ(IS,1001) LINE

*...read total cross section (not used)
      READ(IS,1027) LINE
      READ(LINE,FMT='(G18.3)', ERR=2006) XSIGMAT

*...read number of mixed events (not used)
      READ(IS,1030) LINE
      READ(LINE,FMT='(i10)', ERR=2007) NEVTOT

*...omit string: #Nproc ================== Events ==========================
      READ(IS,1001) LINE
      RETURN

 2001 WRITE(*,*) 'Invalid string for the sqrtS in subprocess = ',NPRC
      STOP
 2002 WRITE(*,*) 'Invalid string for the rapidity in subprocess = ',NPRC
      STOP
 2003 WRITE(*,*) 
     + 'Invalid string for the particle masses in subprocess = ',NPRC
      STOP
 2004 WRITE(*,*) 
     + 'Invalid string for the cross section in subprocess = ',NPRC
      STOP
 2005 WRITE(*,*) 
     + 'Invalid string for the events number in subprocess = ',NPRC
      STOP
 2006 WRITE(*,*) 'Invalid string for the full cross section'
      STOP
 2007 WRITE(*,*) 'Invalid string for the full events number'
      STOP

 1001 FORMAT( 1x,A500)
 1008 FORMAT( 8x,A500)
 1009 FORMAT( 9x,A500)
 1010 FORMAT(10x,A500)
 1017 FORMAT(17x,A500)
 1021 FORMAT(21x,A500)
 1023 FORMAT(23x,A500)
 1027 FORMAT(27x,A500)
 1030 FORMAT(30x,A500)
      END


******************************
* parsing the BNAME strings
******************************
      SUBROUTINE R_BEAM(STRF, BBKF, BBNAME, BBMASS, BNUM)
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
*...Les Houches Agreement I common blocks
      INCLUDE 'LHA.inc'        
*...CompHEP-HERWIG interface
      INCLUDE 'COMPHEPINT.inc'
      SAVE

      CHARACTER*80 STRF
      INTEGER PDFG, PDFS
      INTEGER I, K
      INTEGER BBKF
      INTEGER BNUM
      DOUBLE PRECISION BBMASS
      CHARACTER*80 BBNAME
      
*...Error case
      IF (STRF.eq.'') THEN
         write(*,*) 'Error in STRF'
         stop
      ENDIF

*...Default beam mass
      BBMASS = 0

      DO 10 I = 1, 80
        IF (STRF(I:I).ne.' ') goto 20
10    CONTINUE

*...OFF case
20    IF(STRF(I:(I+2)).EQ.'OFF') THEN
         BBKF  = 0
         BBNAME = 'no'
         RETURN
*...Proton or antiproton beams
      ELSEIF (STRF(I:(I+3)).EQ.'PDF:') THEN
         BBMASS = 0.938    ! mass of proton
         NL     = 2        ! default NLL
         GOTO 50 
*...Electron beams
      ELSEIF(STRF(I:(I+2)).EQ.'ISR')THEN
         BBNAME = 'electron'
         BBMASS = 0.000511   ! mass of electron
         GOTO 99
      ELSEIF(STRF(I:(I+11)).EQ.'Equiv.Photon')THEN
         BBNAME = 'electron'
         BBMASS = 0.000511   ! mass of electron
         GOTO 99
*...Photon beams
      ELSEIF(STRF(i:(i+13)).EQ.'Laser photons')THEN
         BBNAME = 'gamma'
         GOTO 99
      ENDIF

*...Error STRF
      WRITE(*,*) 'Error: Unknown STRF'
      RETURN

*...Proton or anti-proton beams 
50    K = I + 4
      IF(STRF(K:(K+3)).eq.'MRST') THEN
        PDFG = 3
        IF (STRF((K+4):(K+6)).EQ.'c-g')  THEN      ! MRSTc-g
                    NL       = 1       ! LO alpha_s
                    PDFS     = 72      ! mrstc-g
                    QCDLF(5) = 0.2374  ! GeV
                    K1 = k+8
        ENDIF
        IF (STRF((k+4):(k+5)).EQ.'ht')  THEN       ! MSRTht
                    NL       = 2       ! NLO alpha_s
                    PDFS     = 77      ! mrstht
                    QCDLF(5) = 0.2086  ! GeV
                    K1 = k + 7
        ENDIF
        GOTO 55
      ENDIF
           IF((STRF(k:k+3).eq.'cteq').or.(STRF(k:k+3).eq.'CTEQ')) THEN
             PDFG = 4
             IF(STRF((k+4):(k+5)).eq.'6l'.or.
     &          STRF((k+4):(k+5)).eq.'6L') THEN         ! CTEQ6L
                    NL       = 1      !LO alpha_s
                    PDFS     = -1     ! cteq6l (PDFLIB doesnot know CTEQ6!)
                    PDFG     = -1
                    QCDLF(5) = 0.146  ! GeV
                    K1 = k + 7
             ENDIF
             IF(STRF((k+4):(k+6)).eq.'6l1'.or.
     &          STRF((k+4):(k+6)).eq.'6L1') THEN         ! CTEQ6L1
                    NL       = 1      !LO alpha_s
                    PDFS     = -1     ! cteq6l1 (PDFLIB doesnot know CTEQ6!)
                    PDFG     = -1
                    QCDLF(5) = 0.146  ! GeV
                    K1 = k + 8
             ENDIF
             IF(STRF((k+4):(k+5)).eq.'6m'.or.
     &          STRF((k+4):(k+5)).eq.'6M') THEN        ! CTEQ6m
                    NL       = 2      ! NLO alpha_s
                    PDFS     = -1     ! cteq6m (PDFLIB doesnot know CTEQ6!)
                    PDFG     = -1
                    QCDLF(5) = 0.226  ! GeV
                    K1 = k + 7
             ENDIF
             IF(STRF((k+4):(k+5)).eq.'6d'.or.
     &          STRF((k+4):(k+5)).eq.'6D') THEN        ! CTEQ6m
                    NL       = 2      ! NLO alpha_s
                    PDFS     = -1     ! cteq6d (PDFLIB doesnot know CTEQ6!)
                    PDFG     = -1
                    QCDLF(5) = 0.226  ! GeV
                    K1 = k + 7
             ENDIF
             IF(STRF((k+4):(k+5)).eq.'5l'.or.
     &          STRF((k+4):(k+5)).eq.'5L') THEN         ! CTEQ5L
                    NL       = 1      ! NLO alpha_s
                    PDFS     = 46     ! cteq5l
                    QCDLF(5) = 0.146  ! GeV
                    K1 = k + 7
             ENDIF
             IF(STRF((k+4):(k+5)).eq.'5m'.or.
     &          STRF((k+4):(k+5)).eq.'5M') THEN        ! CTEQ5m
                    NL       = 2      ! NLO running alphas
                    PDFS     = 48     ! cteq5m
                    QCDLF(5) = 0.226  ! GeV
                    K1 = k + 7
             ENDIF
             IF(STRF((k+4):(k+6)).eq.'5m1'.or.
     &          STRF((k+4):(k+6)).eq.'5M1') THEN        ! CTEQ5m1
                    NL       = 2      ! NLO running alphas
                    PDFS     = 53     ! cteq5m1
                    QCDLF(5) = 0.226  ! GeV
                    K1 = k + 8
             ENDIF
             IF(STRF((k+4):(k+5)).eq.'4l'.or.
     &          STRF((k+4):(k+5)).eq.'4L') THEN         ! CTEQ4l
                    NL       = 1      ! LO alpha_s
                    PDFS     = 32     ! cteq4l
                    QCDLF(5) = 0.181  ! GeV
                    K1 = k + 7
             ENDIF
             IF(STRF((k+4):(k+5)).eq.'4m'.or.
     &          STRF((k+4):(k+5)).eq.'4M') THEN         ! CTEQ4m
                    NL       = 2      ! NLO running alpha_s
                    PDFS     = 34     ! cteq4m
                    QCDLF(5) = 0.202  ! GeV
                    K1 = k + 7
             ENDIF
           GOTO 55
           ENDIF
           IF(STRF(k:(k+2)).eq.'GRV') THEN
             PDFG = 5
             IF (STRF((k+3):(k+10)).EQ.'98LO')  THEN  ! GRV98LO
                    NL       = 1       ! LO
                    PDFS     = 12      ! grv98lo
                    QCDLF(5) = 0.1529  ! GeV
                    K1 = k + 8
             ENDIF
             IF (STRF((k+3):(k+10)).EQ.'98HO')  THEN
                    NL       = 2       ! NLO running alpha_s
                    PDFS     = 13      ! grv98hp
                    QCDLF(5) = 0.1334  ! GeV
                    K1 = k + 8
             ENDIF
           GOTO 55
           ENDIF

           write(*,*) 'Unknown PDF set for proton/antiproton'
           stop
55    CONTINUE
      
      KK = 1
      DO j = K1, 80
        IF (STRF(J:J).eq.' '.or.STRF(J:J).eq.')') goto 99
        BBNAME(KK:KK) = STRF(J:J)
        KK = KK + 1
      ENDDO

*...get HERWIG's KF code for the BNAME      
99    BBKF = KFBEAM(BBNAME)
      IF (BNUM.EQ.1.or.BNUM.EQ.2) THEN
        PDFGUP(BNUM) = PDFG
        PDFSUP(BNUM) = PDFS
      ELSE
        WRITE(*,*)''
        STOP
      ENDIF
      RETURN
      END


*********************************
* parsing the subprocess string
*********************************
      SUBROUTINE R_PROC(NPRC,PROSTRING)
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
*...CompHEP-HERWIG interface
      INCLUDE 'COMPHEPINT.inc'
      SAVE

      CHARACTER*100 PROSTRING
      CHARACTER*4 PNAME(20)
      INTEGER II
      SAVE

      NNUP(NPRC) = 0
      II = 0

5     CONTINUE
      II = II + 1
      IF (PROSTRING(II:II).EQ.' ') GOTO 15
      IF (PROSTRING(II:II).EQ.'-') THEN
        NIN = NNUP(NPRC)
        GOTO 5
      ENDIF
      IF (PROSTRING(II:II).EQ.'>') GOTO 5
      NNUP(NPRC) = NNUP(NPRC) + 1

      IF (NNUP(NPRC).GT.10) THEN
        WRITE(*,*) 'Warning: More than 10 partons in final state.'
      ELSEIF(NNUP(NPRC).GT.20) THEN
        WRITE(*,*) 'Error:  More than 20 partons in final state.'
        STOP
      ENDIF

      PNAME(NNUP(NPRC)) = PROSTRING(II:II+4)  ! three symbols per particle name
      KFP(NPRC,NNUP(NPRC)) = KFPART(PNAME(NNUP(NPRC)))
      II = II + 3

      IF (KFP(NPRC,NNUP(NPRC)).eq.0) THEN
        WRITE(*,*) 'II = ', II
        WRITE(*,*) 'Unknown particle name: ',PNAME(NNUP(NPRC))
        STOP
      ENDIF

 15   IF (II.GE.100) GOTO 10
      GOTO 5

 10   CONTINUE
      IF (NNUP(NPRC).EQ.0) THEN
        WRITE(*,*) 'Error: No process string in the event file.'
        STOP
      ELSEIF(NIN.EQ.0) THEN
        WRITE(*,*) 'Error: No inital particles in the process string.'
        STOP
      ELSEIF((NNUP(NPRC)-NIN).EQ.0) THEN
        WRITE(*,*) 'Error: No out particles in the process string.'
        STOP
      ELSEIF(NIN.EQ.1) THEN
        WRITE(*,*) 'Error: Decay process is not allowed.'
        STOP
      ELSEIF(NIN.GT.2) THEN
        WRITE(*,*) 
     +  'Error: Process can not contain more then 2 initial particles.'
        STOP
      ENDIF
      RETURN
      END


********************
* make empty string
********************
      FUNCTION EMPTYS(N)
      CHARACTER*(*) EMPTYS
      SAVE
      DO K = 1, N
           EMPTYS(K:K) = ' '
      ENDDO
      RETURN
      END


*******************************
* delete blanks in string
*******************************
      FUNCTION CMPRS(STR)
      CHARACTER*500 STR
      CHARACTER*500 XSTR
      CHARACTER*500 CMPRS
      CHARACTER*500 EMPTYS
      SAVE

      J = 1
      XSTR = EMPTYS(500)
      DO I = 1,80
        IF(STR(I:I).ne.' ') THEN
          XSTR(J:J) = STR(I:I)
          J = J + 1
        ENDIF
      ENDDO
      CMPRS = XSTR
      RETURN
      END
*********************************
* clear Les Houches COMMON BLOCKS
*********************************
      SUBROUTINE CLEAREV
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      IMPLICIT INTEGER(I-N)
*...Les Houches Agreement I common blocks
      INCLUDE 'LHA.inc'

*...the number of particle entries in the current event
      NUP=500

*...the identity of the current subprocess
      IDPRUP=0

*...the event weight
      XWGTUP=0.0

*...scale Q of the event (factorization scale)
      SCALUP=0.0

*...the QED coupling used
      AQEDUP=0.0

*...the QCD coupling used for this event (ME)
      AQCDUP=0.0

*...particle identity code
      DO I=1,NUP
        IDUP(I)=0
      ENDDO

*...status code of particle
      DO I=1,NUP
        ISTUP(I)=0
      ENDDO

      DO I=1,NUP
        MOTHUP(1,I)=0
        MOTHUP(2,I)=0
      ENDDO

*...the particle momenta
      DO NN=1,NUP
        DO MM=1,5
          PUP(MM,NN)=0.d0
        ENDDO
      ENDDO

*...invariant lifetime
      DO I=1,NUP
        VTIMUP(I)=0.d0
      ENDDO

*...spin information
      DO I=1,NUP
        SPINUP(I)=0
        ICOLUP(2,I)=0
        ICOLUP(1,I)=0
      ENDDO
      RETURN
      END
