*************************************************************************
*                         KFBEAM routine                                *
*          for CompHEP 4.*  - HERWIG 6.5  interface                     *
*************************************************************************
      INTEGER FUNCTION KFBEAM(BNAME)
      CHARACTER*16 BNAME

      KFBEAM = 0
      IF (BNAME.EQ.'Proton'.OR.BNAME.EQ.'proton'.or.
     . BNAME.EQ.'p+') THEN 
            KFBEAM = 2212
      ELSEIF (BNAME.EQ.'AntiProton'.OR.BNAME.EQ.'antiProton'.or.
     . BNAME.EQ.'anti-proton'.OR.BNAME.EQ.'pbar-') THEN 
            KFBEAM = -2212
      ELSEIF (BNAME.EQ.'electron'.OR.BNAME.EQ.'e-') THEN 
            KFBEAM = 11
      ELSEIF (BNAME.EQ.'positron'.OR.BNAME.EQ.'e+') THEN 
            KFBEAM = -11
      ELSEIF (BNAME.EQ.'gamma') THEN 
            KFBEAM = 22
      ELSE
            WRITE(*,*) 'Unknown for CompHEP/PYTHIA beam name: ',bname
      ENDIF
      RETURN
      END

*************************************************************************
*                         KFPART routine                                *
*          for CompHEP 4.*  -  HERWIG 6.5 interface                     *
*************************************************************************
      INTEGER FUNCTION KFPART(PNAME)
      CHARACTER*3 PNAME

      IF     (PNAME.EQ.'e1 ') THEN 
            KFPART = 11
      ELSEIF (PNAME.EQ.'E1 ') THEN 
            KFPART = -11
      ELSEIF (PNAME.EQ.'e  ') THEN 
            KFPART = 11
      ELSEIF (PNAME.EQ.'E  ') THEN 
            KFPART = -11
      ELSEIF (PNAME.EQ.'e2 ') THEN 
            KFPART = 13
      ELSEIF (PNAME.EQ.'E2 ') THEN 
            KFPART = -13
      ELSEIF (PNAME.EQ.'m  ') THEN 
            KFPART = 13
      ELSEIF (PNAME.EQ.'M  ') THEN 
            KFPART = -13
      ELSEIF (PNAME.EQ.'e3 ') THEN 
            KFPART = 15
      ELSEIF (PNAME.EQ.'E3 ') THEN 
            KFPART = -15
      ELSEIF (PNAME.EQ.'l  ') THEN 
            KFPART = 15
      ELSEIF (PNAME.EQ.'L  ') THEN 
            KFPART = -15
      ELSEIF (PNAME.EQ.'e4 ') THEN 
            KFPART = 17
      ELSEIF (PNAME.EQ.'E4 ') THEN 
            KFPART = -17
      ELSEIF (PNAME.EQ.'n1 ') THEN 
            KFPART = 12
      ELSEIF (PNAME.EQ.'N1 ') THEN 
            KFPART = -12
      ELSEIF (PNAME.EQ.'ne ') THEN 
            KFPART = 12
      ELSEIF (PNAME.EQ.'Ne ') THEN 
            KFPART = -12
      ELSEIF (PNAME.EQ.'n2 ') THEN 
            KFPART = 14
      ELSEIF (PNAME.EQ.'N2 ') THEN 
            KFPART = -14
      ELSEIF (PNAME.EQ.'nm ') THEN 
            KFPART = 14
      ELSEIF (PNAME.EQ.'Nm ') THEN 
            KFPART = -14
      ELSEIF (PNAME.EQ.'n3 ') THEN 
            KFPART = 16
      ELSEIF (PNAME.EQ.'N3 ') THEN 
            KFPART = -16
      ELSEIF (PNAME.EQ.'nl ') THEN 
            KFPART = 16
      ELSEIF (PNAME.EQ.'Nl ') THEN 
            KFPART = -16
      ELSEIF (PNAME.EQ.'n4 ') THEN 
            KFPART = 18
      ELSEIF (PNAME.EQ.'N4 ') THEN 
            KFPART = -18

      ELSEIF (PNAME.EQ.'d# ') THEN
            KFPART = 1
      ELSEIF (PNAME.EQ.'D# ') THEN
            KFPART = -1
      ELSEIF (PNAME.EQ.'u# ') THEN
            KFPART = 2
      ELSEIF (PNAME.EQ.'U# ') THEN
            KFPART = -2
      ELSEIF (PNAME.EQ.'q# ') THEN
            KFPART = 2
      ELSEIF (PNAME.EQ.'Q# ') THEN
            KFPART = -2

      ELSEIF (PNAME.EQ.'d  ') THEN 
            KFPART = 1
      ELSEIF (PNAME.EQ.'D  ') THEN 
            KFPART = -1
      ELSEIF (PNAME.EQ.'u  ') THEN 
            KFPART = 2
      ELSEIF (PNAME.EQ.'U  ') THEN 
            KFPART = -2
      ELSEIF (PNAME.EQ.'s  ') THEN 
            KFPART = 3
      ELSEIF (PNAME.EQ.'S  ') THEN 
            KFPART = -3
      ELSEIF (PNAME.EQ.'c  ') THEN 
            KFPART = 4
      ELSEIF (PNAME.EQ.'C  ') THEN 
            KFPART = -4
      ELSEIF (PNAME.EQ.'b  ') THEN 
            KFPART = 5
      ELSEIF (PNAME.EQ.'B  ') THEN 
            KFPART = -5
      ELSEIF (PNAME.EQ.'t  ') THEN 
            KFPART = 6
      ELSEIF (PNAME.EQ.'T  ') THEN 
            KFPART = -6
      ELSEIF (PNAME.EQ.'b4 ') THEN 
            KFPART = 7
      ELSEIF (PNAME.EQ.'B4 ') THEN 
            KFPART = -7
      ELSEIF (PNAME.EQ.'t4 ') THEN 
            KFPART = 8
      ELSEIF (PNAME.EQ.'T4 ') THEN 
            KFPART = -8

      ELSEIF (PNAME.EQ.'G  ') THEN 
            KFPART = 21
      ELSEIF (PNAME.EQ.'g  ') THEN 
            KFPART = 21
      ELSEIF (PNAME.EQ.'A  ') THEN 
            KFPART = 22
      ELSEIF (PNAME.EQ.'gamma') THEN 
            KFPART = 22
      ELSEIF (PNAME.EQ.'Z  ') THEN 
            KFPART = 23
      ELSEIF (PNAME.EQ.'Z0 ') THEN 
            KFPART = 23
      ELSEIF (PNAME.EQ.'W+ ') THEN 
            KFPART = 24
      ELSEIF (PNAME.EQ.'W- ') THEN 
            KFPART = -24
      ELSEIF (PNAME.EQ.'H  ') THEN 
            KFPART = 25
      ELSEIF (PNAME.EQ.'h  ') THEN 
            KFPART = 25

      ELSEIF (PNAME.EQ.'h0 ') THEN 
            KFPART = 25
      ELSEIF (PNAME.EQ.'H0 ') THEN 
            KFPART = 35
      ELSEIF (PNAME.EQ.'A0 ') THEN 
            KFPART = 36
      ELSEIF (PNAME.EQ.'H3 ') THEN 
            KFPART = 36
      ELSEIF (PNAME.EQ.'H+ ') THEN 
            KFPART = 37
      ELSEIF (PNAME.EQ.'H- ') THEN 
            KFPART = -37

      ELSEIF (PNAME.EQ.'Gr ') THEN                  ! Graviton
            KFPART = 39
      ELSEIF (PNAME.EQ.'R0 ') THEN 
            KFPART = 41
      ELSEIF (PNAME.EQ.'LQ ') THEN 
            KFPART = 42

      ELSEIF (PNAME.EQ.'~g ') THEN                  ! gluino
            KFPART =  1000021      

      ELSEIF (PNAME.EQ.'~dL') THEN
            KFPART =  1000001
      ELSEIF (PNAME.EQ.'~DL') THEN
            KFPART = -1000001
      ELSEIF (PNAME.EQ.'~dR') THEN
            KFPART =  2000001
      ELSEIF (PNAME.EQ.'~DR') THEN
            KFPART = -2000001
      ELSEIF (PNAME.EQ.'~uL') THEN
            KFPART =  1000002 
      ELSEIF (PNAME.EQ.'~UL') THEN
            KFPART = -1000002 
      ELSEIF (PNAME.EQ.'~uR') THEN
            KFPART =  2000002
      ELSEIF (PNAME.EQ.'~UR') THEN
            KFPART = -2000002
      ELSEIF (PNAME.EQ.'~sL') THEN
            KFPART =  1000003  
      ELSEIF (PNAME.EQ.'~SL') THEN
            KFPART = -1000003 
      ELSEIF (PNAME.EQ.'~sR') THEN
            KFPART =  2000003 
      ELSEIF (PNAME.EQ.'~SR') THEN
            KFPART = -2000003
      ELSEIF (PNAME.EQ.'~cL') THEN
            KFPART =  1000004
      ELSEIF (PNAME.EQ.'~CL') THEN
            KFPART = -1000004
      ELSEIF (PNAME.EQ.'~cR') THEN
            KFPART =  2000004 
      ELSEIF (PNAME.EQ.'~CR') THEN
            KFPART = -2000004
      ELSEIF (PNAME.EQ.'~b1') THEN
            KFPART =  1000005 
      ELSEIF (PNAME.EQ.'~B1') THEN
            KFPART = -1000005
      ELSEIF (PNAME.EQ.'~b2') THEN
            KFPART =  2000005
      ELSEIF (PNAME.EQ.'~B2') THEN
            KFPART = -2000005
      ELSEIF (PNAME.EQ.'~t1') THEN
            KFPART =  1000006
      ELSEIF (PNAME.EQ.'~T1') THEN
            KFPART = -1000006
      ELSEIF (PNAME.EQ.'~t2') THEN
            KFPART =  2000006 
      ELSEIF (PNAME.EQ.'~T2') THEN
            KFPART = -2000006 
      ELSEIF (PNAME.EQ.'~eL') THEN
            KFPART =  1000011
      ELSEIF (PNAME.EQ.'~EL') THEN
            KFPART = -1000011
      ELSEIF (PNAME.EQ.'~eR') THEN
            KFPART =  2000011 
      ELSEIF (PNAME.EQ.'~ER') THEN
            KFPART = -2000011
      ELSEIF (PNAME.EQ.'~ne') THEN
            KFPART =  1000012
      ELSEIF (PNAME.EQ.'~Ne') THEN
            KFPART = -1000012   
      ELSEIF (PNAME.EQ.'~mL') THEN
            KFPART =  1000013 
      ELSEIF (PNAME.EQ.'~ML') THEN
            KFPART = -1000013 
      ELSEIF (PNAME.EQ.'~mR') THEN
            KFPART =  2000013
      ELSEIF (PNAME.EQ.'~MR') THEN
            KFPART = -2000013
      ELSEIF (PNAME.EQ.'~nm') THEN
            KFPART =  1000014 
      ELSEIF (PNAME.EQ.'~Nm') THEN
            KFPART = -1000014
      ELSEIF (PNAME.EQ.'~l1') THEN
            KFPART =  1000015
      ELSEIF (PNAME.EQ.'~L1') THEN 
            KFPART = -1000015
      ELSEIF (PNAME.EQ.'~l2') THEN
            KFPART =  2000015 
      ELSEIF (PNAME.EQ.'~L2') THEN
            KFPART = -2000015
      ELSEIF (PNAME.EQ.'~nl') THEN
            KFPART =  1000016  
      ELSEIF (PNAME.EQ.'~Nl') THEN
            KFPART = -1000016
 
      ELSEIF (PNAME.EQ.'~o1') THEN                  ! neutralino chi_10
            KFPART =  1000022
      ELSEIF (PNAME.EQ.'~o2') THEN                  ! neutralino chi_20
            KFPART =  1000023 
      ELSEIF (PNAME.EQ.'~o3') THEN                  ! neutralino chi_30
            KFPART =  1000025 
      ELSEIF (PNAME.EQ.'~o4') THEN                  ! neutralino chi_40
            KFPART =  1000035 
      ELSEIF (PNAME.EQ.'~1+') THEN                  ! chargino chi_1+
            KFPART =  1000024
      ELSEIF (PNAME.EQ.'~1-') THEN                  ! chargino chi_1-
            KFPART = -1000024
      ELSEIF (PNAME.EQ.'~2+') THEN                  ! chargino chi_2+
            KFPART =  1000037
      ELSEIF (PNAME.EQ.'~2-') THEN                  ! chargino chi_2-
            KFPART = -1000037
c... other lebel for chargino (from extra-dimention theories)
      ELSEIF (PNAME.EQ.'KG') THEN                  ! chargino chi_2-
            KFPART =  1000037

      ELSEIF (PNAME.EQ.'~G') THEN                   ! gravitino
            KFPART = 1000039
      ELSEIF (PNAME.EQ.'~sS') THEN                  ! sgoldstino S
            KFPART = 1000040
      ELSEIF (PNAME.EQ.'~sP') THEN                  ! sgoldstino P
            KFPART = 1000041
      ELSE 
            KFPART = 0
      ENDIF
      RETURN
      END
