*************************************************************************
*                       M A I N   program                               *
*          for CompHEP 4.*  -  PYTHIA 6.2 interface                     *
*************************************************************************
      PROGRAM CPYTHIA
*...PYTHIA common blocks
      INCLUDE 'PYTHIA62.inc'        
*...Les Houches Agreement I common blocks
      INCLUDE 'LHA.inc'        
*...CompHEP-HERWIG interface common block
      INCLUDE 'COMPHEPINT.inc'
      SAVE

      INTEGER NNEV, IEV

*...switch to smear the mass of unstable particles in CompHEP out-state
      ISMEAR = 1     ! 0 - no Breit-Wigner smearing, 1- yes

*...read CompHEP output header and input parameters
      CALL CBEGIN

*************   USER can change these switches or add others ********
      MSTJ(1)   = 1  ! Independent(MSTJ(1)=2)/LUND(=1)/NO(=0) Fragmentation Model switch
      MSTP(111) = 1  ! switch on/off fragmentation and decays
      MSTP(61)  = 1  ! switch on/off initial QCD and QED state radiation
      MSTP(71)  = 1  ! switch on/off final state showers
      MSTP(81)  = 0  ! switch off multiple interactions
      MSTU(12)  = 0  ! title page off
      MSTP(122) = 0  ! no initialization and diff.cross-section maximization print-out

********************************************************************
*...initialize PYTHIA (using CompHEP output for kin.frame)
      CALL PYINIT('USER',' ',' ',0d0)
      CALL PHYSPARS   ! set AGAIN phys. parameters according to CompHEP defaults

*********************************************************
*...Print HEPRUP common block data
      CALL HEPRUP_PRINT

*...Pass CompHEP events to HERWIG
      NNEV = 0      
      DO 200 IEV = 1, NEVPY
        CALL PYEVNT

*...<<<<<<< USER's routines for analysis should be call here >>>>>> 
        CALL HEPEUP_PRINT   ! Print other parameters from HEPEUP Common block
        CALL PYLIST(7)    ! This is an example of user's routine:
        CALL PYLIST(2)    ! This is an example of user's routine:
*...<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

*...Check end of file with partonic events
        IF (NUP.eq.0) THEN
            GOTO 300
        ELSE
            NNEV = iev
        ENDIF
200   CONTINUE    ! main loop

300   CALL CEND

*...Final statistics
      CALL PYSTAT(1)

      WRITE(*,*) '  Generated events = ',NNEV

      END
