*************************************************************************
*                          UPEVNT routine                               *
*          for CompHEP 41.10  -  PYTHIA 6.2 interface                   *
*************************************************************************
*  25.11.2001       Ilyin V.A.                                          *
*************************************************************************
      SUBROUTINE UPEVNT
*...Les Houches Agreement I common blocks
      INCLUDE 'LHA.inc'
*...CompHEP-HERWIG interface
      INCLUDE 'COMPHEPINT.inc'

      DOUBLE PRECISION  PP(20,4), PYR
      INTEGER NPRC
      CHARACTER*500 LINE
      CHARACTER*60 CHAIN
      CHARACTER*1 K1
      CHARACTER*1 K2
      CHARACTER*2 XN

      LOGICAL FIRST
      DATA FIRST/.TRUE./
      SAVE
       
      IPSGN = 1
*...if BEAM(1)=BEAM(2) the simmetrization Z->-Z is made
      IF (KFB(1).eq.KFB(2)) THEN
        IF (FIRST) THEN
          FIRST = .FALSE.
          IDUM = -1
        ENDIF
        XRND = pyr(0)
        IF (XRND.lt.0.5d0) IPSGN = -1
        IF (XRND.lt.0.d0 .or. XRND.ge.1.d0) THEN
          WRITE(*,*) 'Random generator is out of [0,1)! Stop!'
          STOP
        ENDIF
      ENDIF

*...read current event
      PP(1,1) = 0d0
      PP(1,2) = 0d0
      PP(2,1) = 0d0
      PP(2,2) = 0d0
      READ (IS,FMT='(A500)',END=1000,ERR=1000) LINE
      READ (LINE,FMT='(i6)') NPRC
      Num=3*(NNUP(NPRC)-2)+2
      CALL ITOCHR(XN,NUM)
      READ(LINE,FMT='(i6,'//XN//'G18.10,G12.3,1x,A)',END=1000,
     .ERR=1000)  NPRC,PP(1,3),PP(2,3),((PP(N,J),J=1,3),N=3,NNUP(NPRC)),
     .QUP,chain

*... random phi generation 
      PI      = DACOS(-1d0)
      PHI_RND = 2D0*PI*PYR(0)
      DO N = 3, NNUP(NPRC)
        XX = PP(N,1)
	YY = PP(N,2)
	PP(N,1) = XX * COS(PHI_RND) - YY * SIN(PHI_RND)
	PP(N,2) = XX * SIN(PHI_RND) + YY * COS(PHI_RND)
      ENDDO

*...the number of particle entries in the current event
      NUP    =  NNUP(NPRC)

*...the identity of the current subprocess
      IDPRUP = LPRUP(NPRC)

*...the event weight
      XWGTUP = 1.d0

*...scale Q of the event (factorization scale)
      SCALUP = QUP

*...the QED coupling used
      AQEDUP = -1    ! not QED process

*...the QCD coupling used for this event (ME)
      AQCDUP = ALPHAS2(SCALUP,QCDLF(5),NNL)  ! the same as factorization scale

*...particle identity code
      DO I = 1, NUP
        IDUP(I) = KFP(NPRC,I)
      ENDDO

*...status code of particle
      ISTUP(1) = -1
      ISTUP(2) = -1
      DO I = 3, NUP
        ISTUP(I) = 1
      ENDDO

*...position of the first and last mother of particle
      MOTHUP(1,1) = 0 
      MOTHUP(2,1) = 0 
      MOTHUP(1,2) = 0 
      MOTHUP(2,2) = 0 
      DO I = 3, NUP
        MOTHUP(1,I) = 1 
        MOTHUP(2,I) = 2
      ENDDO

*...the particle momenta
      DO NN = 1, NUP
        PUP(1, NN) = PP(NN, 1)
        PUP(2, NN) = PP(NN, 2)
        PUP(3, NN) = PP(NN, 3) * IPSGN
        PUP(4, NN) = 
     +	SQRT(PP(NN,1)**2 + PP(NN,2)**2 + PP(NN,3)**2 + XM(NPRC,NN,1)**2)
        PUP(5, NN) = XM(NPRC, NN, 1)
      ENDDO

*...invariant lifetime
      DO I = 1, NUP
        VTIMUP(I) = 0.d0
      ENDDO

*...spin information
      DO I = 1, NUP
        SPINUP(I) = 9
      ENDDO


*...swap Z axis for momenta if BEAM(1)=BEAM(2)
        IF (IPSGN.eq.-1) THEN
          IDUPX   = IDUP(1)
          IDUP(1) = IDUP(2)
          IDUP(2) = IDUPX
          DO 135 I=1,5
             XPUP     = PUP(I,1)
             PUP(I,1) = PUP(I,2)
135          PUP(I,2) = XPUP
        ENDIF

*...Breit-Wigner smearing of masses for unstable particles in OUT state if yes
       IF (ISMEAR.EQ.1) CALL SMEARMASS

*...set color flows
      DO 10 I=1,30
       IF (CHAIN(I:I+1).EQ.') ') LENGTH=I
10    CONTINUE       
      ITAG = 500
      DO 111 I=1,NUP
        ICOLUP(1,i) = 0
        ICOLUP(2,i) = 0
111   CONTINUE
      DO 222 I=1,LENGTH,5
        K1=CHAIN(I+1:I+1)
        N1=NUMBER(K1)
        K2=CHAIN(I+3:I+3)
        N2=NUMBER(K2)
        IF (IPSGN.eq.-1) THEN
          IF (N1.eq.1) THEN
                 N1=2
          ELSEIF (N1.eq.2) THEN
                 N1=1
          ENDIF
          IF (N2.eq.1) THEN
                 N2=2
          ELSEIF (N2.eq.2) THEN
                 N2=1
          ENDIF
        ENDIF
        IF (N1.le.2) THEN
          ICOLUP(1,N1) = ITAG
        ELSE
          ICOLUP(2,N1) = ITAG
        ENDIF
        IF (N2.le.2) THEN
          ICOLUP(2,N2) = ITAG
        ELSE
          ICOLUP(1,N2) = ITAG
        ENDIF
        ITAG = ITAG+1
222   CONTINUE

      RETURN
*...EOF or error in reading events from CompHEP output
1000  NUP = 0
      RETURN
      END


*******************************************************
*                    FUNCTION                         *
*******************************************************
      FUNCTION NUMBER(PARTON)
      CHARACTER*1 PARTON
      IF (PARTON.EQ.'1') THEN 
      NUMBER = 1
       ELSEIF(PARTON.EQ.'2') THEN
       NUMBER = 2
        ELSEIF(PARTON.EQ.'3') THEN
	NUMBER = 3
         ELSEIF(PARTON.EQ.'4') THEN
	 NUMBER = 4
          ELSEIF(PARTON.EQ.'5') THEN
	  NUMBER = 5
	   ELSEIF(PARTON.EQ.'6') THEN
	   NUMBER = 6
	    ELSEIF(PARTON.EQ.'7') THEN
	    NUMBER = 7
	     ELSEIF(PARTON.EQ.'8') THEN
	     NUMBER = 8
	      ELSEIF(PARTON.EQ.'9') THEN
              NUMBER = 9  
	      ELSE
	      NUMBER = 10
      ENDIF
      END 
	 

*******************************************************
*                    FUNCTION                         *
* Conversion of integer number into character string  *
*******************************************************
*   Input:  ICHR - output string,                     *
*           JJ - integer number under the conversion; *
*   Output: ITOCHR - the character string,            *
*             declare ICHR at least as                *
*                CHARACTER*LENINT(JJ)                 *
*******************************************************
      SUBROUTINE ITOCHR(ICHR,JJ)
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      IMPLICIT INTEGER(I-N)

      CHARACTER ICHR*(*)
      CHARACTER XFMT*10,XCC

      ICHR=' '
      WRITE(XCC,FMT='(I1)') LENINT(JJ)
      XFMT='(I'//XCC//')'
      WRITE(ICHR,FMT=XFMT,err=1) JJ

      goto 9000
1     write(*,*) 'Error in ITOCHR.'
      read(*,*)

9000  RETURN
      END


********************************************
*           FUNCTION                       *
*     Length of the integer number         *
********************************************
      INTEGER FUNCTION LENINT(JJ)
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      IMPLICIT INTEGER(I-N)

      KK=1
10    CONTINUE
      IF (JJ .LT. 10**KK) THEN
         LLL=KK
         GOTO 20
      ENDIF
      KK=KK+1 
      GOTO 10

20    LENINT=LLL
      RETURN
      END
