/* (C) 2002-2003, CompHEP Collaboration
 * (C) 2006, Alexander Sherstnev
 *----------------------------------------------
 *
 * $Id: tag_parser.c,v 1.10 2003/11/01 21:45:32 kryukov Exp $
 *
 * $Log: tag_parser.c,v $
 * Revision 1.10  2003/11/01 21:45:32  kryukov
 * Copyright record
 *
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "tag_parser.h"

/**************************************************/
char * str_cpy_both (char * src, char * dest) {
  int i;
  int len;
  char * temp;

  len = strlen (dest);
  temp = malloc (len * sizeof (char));
  for (i = 0; i < len - 1; i++)
    temp[i] = dest[i + 1];
  strncpy (src, temp, len - 2);
  src[len - 2] = '\0';
  return src;
}

/**************************************************/
char * str_cpy_left (char * src, char * dest) {
  int i;
  int len;
  char * temp;

  len = strlen (dest);
  temp = malloc (len * sizeof (char));
  for (i = 0; i < len - 1; i++)
    temp[i] = dest[i + 1];
  strncpy (src, temp, len - 1);
  src[len - 1] = '\0';
  return src;
}

/**************************************************/
int intlen (int src) {
  int i = 0;
  int digit = 1;

  while (abs (src / digit) >= 1.0) {
    digit *= 10;
    i++;
  }
  return i;
}

/**************************************************/
string_comnd * command_parser (char * comstr, string_comnd * c) {
  int j, k;
  int type2;
  int namelen, vallen;
  char * temp;
  char * value;
  int len = strlen (comstr);

  if (NULL != c) c = NULL;
  c = malloc(sizeof(string_comnd));
  c->name = NULL;
  c->value = NULL;

  if (0 == len) return c;
  temp = strchr(comstr,'=');
  if (NULL == temp) return c;

  vallen = strlen(temp) - 1;
  namelen = len - vallen - 1;
  c->name = malloc ((namelen + 1) * sizeof(char));
  strncpy (c->name, comstr, namelen);
  c->name[namelen] = '\0';

  value = malloc (vallen * sizeof(char));
  str_cpy_left (value, temp);

  type2 = 0;
  for (j = 0; j < vallen; ++j) {
    if ('\'' == value[j]) ++type2;
  }

  c->type = 1;
  c->value = malloc(vallen * sizeof(char));
  switch (type2) {
   case 0: 
     strcpy(c->value, value);
     break;
   case 2: 
     c->type = 2;
     c->value = str_cpy_both (c->value, value);
     break;
   default:
     fprintf (stderr, "Error! strange command: %s\n", comstr);
     exit (-2);
     break;
  }
  return c;
}


/**************************************************/
int
get_tag (int first, tags * base, char * name)
{
  int i, n;

  n = base->tbasesize;
  if (first <= n) {
    for (i = first; i < n; i++) {
      if (!strcmp (base->tag[i].tagname, name)) {
        return i;
      }
    }
  }
  return -1;
}


/**************************************************/
int
get_tag_with1com (int first, tags * base, char * tagname, string_comnd * com)
{
  int i, j, n;
  string_comnd * temp;

  n = base->tbasesize;
  if (first <= n) {
    for (i = first; i < n; i++) {
      if (!strcmp (base->tag[i].tagname, tagname)) {
        for (j = 0; j < base->tag[i].tagsize; j++) {
          temp = command_parser (base->tag[i].commands[j], temp);
          if (!strcmp (com->name, temp->name)) {
            strcpy (com->value, temp->value);
            return i;
          }
        }
      }
    }
  }
  return -1;
}


/**************************************************/
int get_tag_with_exactcom (int first, tags * base, char * tagname, string_comnd * com)
{
  int i, j, n;
  string_comnd * temp;

  n = base->tbasesize;
  if (first <= n) {
    for (i = first; i < n; i++) {
      if (!strcmp (base->tag[i].tagname, tagname)) {
        for (j = 0; j < base->tag[i].tagsize; j++) {
          temp = command_parser (base->tag[i].commands[j], temp);
          if (!strcmp (com->name, temp->name) && !strcmp (com->value, temp->value)) {
            return i;
          }
        }
      }
    }
  }
  return -1;
}


/**************************************************/
int
get_tag_with_exact2com (int first, tags * base, char * tagname, string_comnd * com1, string_comnd * com2)
{
  int i, j, n;
  int in[2];
  int stop = 1;
  string_comnd * temp;

  n = base->tbasesize;
  if (first > n)
    return -1;

  i = first - 1;
  while (stop) {
    i++;
    if (!strcmp (base->tag[i].tagname, tagname)) {
      in[0] = 0;
      in[1] = 0;
      for (j = 0; j < base->tag[i].tagsize; j++) {
        temp = command_parser (base->tag[i].commands[j], temp);
        if (!strcmp (com1->name, temp->name) && !strcmp (com1->value, temp->value))
          in[0] = i;
        if (!strcmp (com2->name, temp->name) && !strcmp (com2->value, temp->value))
          in[1] = i;
      }
      if ((in[0] && in[1]) || i == n)
          stop = 0;
    }
  }

  if (in[0] && in[1])
    return in[0];
  else
    return -1;
}


/**************************************************/
int tag_contain_com (string_comnd * com, elementary_tag t) {
  int i;
  string_comnd * temp;

  for (i = 0; i < t.tagsize; i++) {
    temp = command_parser (t.commands[i], temp);
    if (!strcmp (com->name, temp->name)) {
      strcpy (com->value, temp->value);
      return i;
    }
  }

  return 0;
}


/**************************************************/
int tag_contain_exactcom (string_comnd com, elementary_tag t) {
  int i;
  string_comnd * temp;

  for (i = 0; i < t.tagsize; i++) {
    temp = command_parser (t.commands[i], temp);
    if (!strcmp (com.name, temp->name) && !strcmp (com.value, temp->value)) {
      return 1;
    }
  }
  return 0;
}


/**************************************************/
int
get_ival (int n, char * cname, elementary_tag t)
{
  int i;
  string_comnd * temp;

  if (n < 1 ) n = 1;
  for (i = n - 1; i < t.tagsize; i++) {
    temp = command_parser (t.commands[i], temp);
    if (!strcmp (cname, temp->name))  return atoi (temp->value);
  }
  return -1;
}


/**************************************************/
double
get_fval (int n, char * cname, elementary_tag t)
{
  int i;
  string_comnd * temp;

  for (i = 0; i < t.tagsize; i++) {
    temp = command_parser (t.commands[i], temp);
    if (!strcmp (cname, temp->name)) return atof (temp->value);
  }
  return 0.0;
}


/**************************************************/
char * get_val (int n, char * cname, elementary_tag t)
{
  int i;
  string_comnd * temp;

  for (i = 0; i < t.tagsize; i++) {
    temp = command_parser (t.commands[i], temp);
    if (!strcmp (cname, temp->name)) {
      char * res = malloc ((strlen (temp->value) + 1) * sizeof (char));
      strcpy (res, temp->value);
      free (temp);
      return res;
    }
  }
  return "";
}

/**************************************************/
int
replace_com (string_comnd com, elementary_tag * t)
{
  int i;
  string_comnd * temp;

  for (i = 0; i < t->tagsize; i++) {
    temp = command_parser (t->commands[i], temp);
    if (!strcmp (com.name, temp->name)) {
      if (!(t->commands[i]))
        free (t->commands[i]);
      t->commands[i] = malloc ((strlen (com.name) + strlen (com.value) + 2) * sizeof (char));
      sprintf (t->commands[i], "%s=%s", com.name, com.value);
      return i;
    }
  }
  return -1;
}


/**************************************************/
int
change_ival (int newval, int shift, string_comnd com, elementary_tag * t)
{
  int i, j;
  int len;
  char * format;
  string_comnd * temp;

  for (i = 0; i < t->tagsize; i++) {
    temp = command_parser (t->commands[i], temp);
    if (!strcmp (com.name, temp->name)) {
      len = strlen (com.name) + shift + intlen (newval) + 1;
      if (!(t->commands[i]))
        free (t->commands[i]);
      t->commands[i] = malloc (len * sizeof (char));
      format = malloc ((shift + 5) * sizeof (char));
      strcpy (format, "%s=");
      for (j = 0; j < shift; j++)
        format[j + 3] = ' ';
      format[shift + 3] = '\0';
      strcat (format, "%i");
      sprintf (t->commands[i], format, temp->name, newval);
      return 1;
    }
  }
  return -1;
}


/**************************************************/
int
change_fval (double newval, string_comnd com, elementary_tag * t)
{
  int i;
  string_comnd * temp;

  for (i = 0; i < t->tagsize; i++) {
    temp = command_parser (t->commands[i], temp);
    if (!strcmp (com.name, temp->name)) {
      if (!(t->commands[i]))
        free (t->commands[i]);
      t->commands[i] = malloc ((strlen (com.name) + 13) * sizeof (char));
      sprintf (t->commands[i], "%s=%.5E", com.name, newval);
      return 1;
    }
  }
  return -1;
}


/**************************************************/
int
change_cval (char *newval, string_comnd com, elementary_tag * t)
{
  int i;
  string_comnd * temp;

  for (i = 0; i < t->tagsize; i++) {
    temp = command_parser (t->commands[i], temp);
    if (!strcmp (com.name, temp->name)) {
      if (!(t->commands[i]))
        free (t->commands[i]);
      t->commands[i] = malloc ((strlen (com.name) + strlen (newval) + 2) * sizeof (char));
      sprintf (t->commands[i], "%s=%s", com.name, newval);
      return 1;
    }
  }
  return -1;
}
