#ifndef _TAGBASE_H_
#define _TAGBASE_H_

typedef struct string_comnd{
  int type;
  char * name;
  char * value;
} string_comnd;

typedef struct elementary_tag {
  int tagsize;
  int used;
  char * tagname;
  char ** commands;
} elementary_tag;

typedef struct tags {
  int tbasesize;
  char * basename;
  elementary_tag * tag;
} tags;

/**************************************************************************************************/
/* init a command/tag/tagbase with corresponding names, return the command/tag/tagbase    */
extern elementary_tag * inittag1 (elementary_tag * tag, char * name);
extern elementary_tag * inittag (char * name);
extern tags * initcap (tags * the_tags, char * name);
extern tags * initcap1 (char * name);
extern string_comnd * initcom (string_comnd * c, char * name, char * val, int type);

/**************************************************************************************************/
/* compute lenth of a command/tag/tagbase                  */
extern int baselen (tags * t);
extern int taglen (elementary_tag * t);
extern int comlen (string_comnd * t);

/**************************************************************************************************/
/* add a comand C to end of a tag T, returns the tag.               */
/* remove a comand with a name CNAME from a tag T, returns the tag. */
extern elementary_tag * add_com (elementary_tag * t, string_comnd * c);
extern int addcom (char ***t, int OldRows, char * line);
extern elementary_tag * remove_com (elementary_tag * t, char * cname);

/**************************************************************************************************/
/* add a tag T to end of a tagbase BASE, returns the tagbase.           */
/* remove a tag with a name TNAME from a tagbase BASE, returns the tag. */
extern tags * add_tag (tags * base, elementary_tag * tag);
extern tags * remove_tag (tags * base, char * tname);

/**************************************************************************************************/
extern elementary_tag * tagcpy (elementary_tag * src, elementary_tag * dist);

/**************************************************************************************************/
extern int event_parser (char * in, char ** eventword);
extern int printtag (FILE * f, elementary_tag * t);
extern int printtagbase (FILE * f, tags * b);
extern int freetag (elementary_tag * t);

#endif /* tag_base.h  */
